package org.brynhild.controller;

import jdk.jfr.internal.tool.Main;
import org.brynhild.common.transfer.dto.Result;
import org.brynhild.common.utils.StringUtil;
import org.brynhild.common.utils.TimeUtil;
import org.brynhild.office.csv.*;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.File;
import java.sql.Time;
import java.util.*;

@RestController
@RequestMapping("/c4")
public class Chapter4Controller {

    @GetMapping("/f1")
    public Result C4F1() {
        try {
//            CSVReader reader = new CSVReader("dataSet" + File.separator + "Wuhan-2019-nCoV.csv");
            CSVReader reader = new CSVReader("dataSet" + File.separator + "c4f1.csv");
            String[] provinceList = new String[]{"北京市", "天津市", "河北省", "山西省", "内蒙古自治区", "辽宁省", "吉林省",
                    "黑龙江省", "上海市", "江苏省", "浙江省", "安徽省", "福建省", "江西省", "山东省",
                    "河南省", "湖北省", "湖南省", "广东省", "广西壮族自治区", "海南省", "重庆市", "四川省",
                    "贵州省", "云南省", "西藏自治区", "陕西省", "甘肃省", "青海省", "宁夏回族自治区", "新疆维吾尔自治区",
                    "台湾省", "香港特别行政区", "澳门特别行政区"};
            final Column province = reader.getColumn("province");
            final Column date = reader.getColumn("date");
            final Column city = reader.getColumn("city");
            final Column confirmed = reader.getColumn("confirmed");

            final String[] dateList=new String[]{"2020-01-22","2020-01-31","2020-06-01","2020-06-12"};

            final CSVReader compute = new CSVPrepare(reader)
                    .addPredicate(row -> StringUtil.isEmpty(row.get(city)))
                    .addPredicate(row -> StringUtil.anyMatch(row.get(province), provinceList))
                    .addPredicate(row -> StringUtil.anyMatch(row.get(date),dateList))
                    .compute();

            Map<String,Integer> nodeData1=new HashMap<>();
            Map<String,Integer> nodeData2=new HashMap<>();
            Map<String,Integer> nodeData3=new HashMap<>();
            Map<String,Integer> nodeData4=new HashMap<>();
            for(String split:provinceList){
                nodeData1.put(split,0);
                nodeData2.put(split,0);
                nodeData3.put(split,0);
                nodeData4.put(split,0);
            }

//            new CSVWriter(compute,"dataSet"+File.separator+"c4f1.csv").write().finish();



            final List<Row> rows = compute.getRows();

            for(Row row:rows){
                final String dateString = row.get(date);
                if(dateString.equals(dateList[0])){
                    nodeData1.put(row.get(province),row.get(confirmed,Integer.class));
                }
                if(dateString.equals(dateList[1])){
                    nodeData2.put(row.get(province),row.get(confirmed,Integer.class));
                }
                if(dateString.equals(dateList[2])){
                    nodeData3.put(row.get(province),row.get(confirmed,Integer.class));
                }
                if(dateString.equals(dateList[3])){
                    nodeData4.put(row.get(province),row.get(confirmed,Integer.class));
                }
            }

            String[] provinceMappingList = new String[]{"北京", "天津", "河北", "山西", "内蒙古", "辽宁", "吉林",
                    "黑龙江", "上海", "江苏", "浙江", "安徽", "福建", "江西", "山东",
                    "河南", "湖北", "湖南", "广东", "广西", "海南", "重庆", "四川",
                    "贵州", "云南", "西藏", "陕西", "甘肃", "青海", "宁夏", "新疆",
                    "台湾", "香港", "澳门"};

            Map<String,Integer> dataMap1=new HashMap<>();
            Map<String,Integer> dataMap2=new HashMap<>();
            Map<String,Integer> dataMap3=new HashMap<>();
            Map<String,Integer> dataMap4=new HashMap<>();
            for(int i=0;i<provinceList.length;i++){
                dataMap1.put(provinceMappingList[i],nodeData1.get(provinceList[i]));
                dataMap2.put(provinceMappingList[i],nodeData2.get(provinceList[i]));
                dataMap3.put(provinceMappingList[i],nodeData3.get(provinceList[i]));
                dataMap4.put(provinceMappingList[i],nodeData4.get(provinceList[i]));
            }

            Map<String,Object> ret=new HashMap<String, Object>(){{
                put("dates",dataMap1);
                put("datess",dataMap2);
                put("datesss",dataMap3);
                put("datessss",dataMap4);
            }};
            return new Result(true, 200, "查询成功",ret);
        } catch (Exception e) {
            e.printStackTrace();
            return new Result(false, 500, "发生错误", e.getMessage());
        }
    }
}
